﻿Public Class Form1
    ' This example doesn't really do anything, it just shows
    ' how the SortOrderItems subroutine might protect itself
    ' against errors.

    Private Sub SortOrderItems(ByVal the_order As Order)
        ' Validate input.
        Debug.Assert(the_order.Items IsNot Nothing, "No items in order")
        Debug.Assert(the_order.Customer IsNot Nothing, "No customer in order")
        Debug.Assert(the_order.Items.Count < 100, "Too many order items")
        '...

        ' Sort the items.
        '...

        ' Validate output.
#If DEBUG Then
        ' Verify that the items are sorted.
        Dim order_item1 As OrderItem
        Dim order_item2 As OrderItem
        order_item1 = DirectCast(the_order.Items(1), OrderItem)
        For i As Integer = 2 To the_order.Items.Count
            order_item2 = DirectCast(the_order.Items(i), OrderItem)
            Debug.Assert(order_item1.price <= order_item2.price,
                "Order items not properly sorted")
            order_item1 = order_item2
        Next i
#End If
    End Sub
End Class

Public Class Order
    Public Items As Collection
    Public Customer As Customer
End Class

Public Class Customer

End Class

Public Class OrderItem
    Public price As Decimal
End Class
